        .386
        .model flat,stdcall

        PUBLIC  Breaks,CheckBreak

        extrn WriteChar : PROC, PrintByte : PROC, PrintDword : PROC
        extrn membase : dword, WadeSpace : PROC, ReadNumber : PROC
        extrn PrintSpace : PROC, crlf : PROC, ReadAddress : PROC

	.data
breaklist dd 8  DUP (-1)         ; List of breakpoints
                                ; breakpoints being set then a run
	
	.code
CheckBreak PROC
        mov     ecx,8
        mov     edi,offset breaklist
        repne   scasd
        ret
CheckBreak ENDP
ClearAllBreaks PROC
        mov     eax,-1
        mov     ecx,8
        mov     edi,offset breaklist
        rep     stosd
        ret
ClearAllBreaks ENDP
;
; Command to set a breakpoint comes here
; INPUT: AX contains break number
;	EBX contains break address
;
setbreak        PROC 
        and     eax,7 
        add     ebx,[membase]  
        mov     [breaklist + eax * 4],ebx
        ret
setbreak	ENDP	
;
; Command to clear a breakpoint comes here
; INPUT: AX has break number to clear in bitmap
;
ClearBreak      PROC    
        and     eax,7
        mov     [breaklist + eax *4],-1
	ret
ClearBreak      ENDP    
;
; Command to display a breakpoint comes here
; INPUT: AX contains index into breaknum bitmap
;
displaybreak	PROC	
        and     eax,07h          ; just in case (shouldn't happen)
        cmp     [eax*4 + breaklist],-1
        jz      nodisplay
        push    eax              ; save index
	call	crlf		; new line
        pop     eax              ; restore index
        push    eax              ; save again
        call    PrintByte       ; Print breakpoint #
        mov     al,':'          ; Print ':'
        call    WriteChar
        call    PrintSpace
        pop     eax              ; restore index
        mov     eax,[eax*4 + breaklist]
        sub     eax,[membase]
        call    PrintDword
nodisplay:
	ret
displaybreak	ENDP	
;
; Handle breakpoint-related commands
; INPUT: SI points to input line text
;	
;
Breaks  PROC    
	call	WadeSpace	; Wade through spaces
	jz	short showall	; Show all breakpoints
	cmp	al,'-'		; Else check for '-'
        pushfd                   ;
	jne	noinc		;
        inc     esi              ; Skip to next arg
	call	WadeSpace	;
noinc:
	cmp	al,'*'		;clear everything?
	je	clearall	;do it if so
	call    ReadNumber	; Read break number
	jc	short badbreak2	; Exit if error
        cmp     eax,8           ; Make sure in range
	jae	short badbreak2	; Exit if error
        popfd                    ;
        push    eax              ; save break number
	jz	short unmake	; If was '-', clear break
	call	WadeSpace	; Else wade to next arg
	jz	badbreak2	; error if not found
	call	ReadAddress	; Read the bp address
        pop     eax              ; restore break number
	jc	short badbreak	; Quit if error
	call	setbreak	; Set breakpoint at this address
	jmp	short breakdone	; Get out
unmake:
	call	WadeSpace	; Wade to end
        pop     eax              ; restore break number
	jnz	short badbreak	; If there is more we have an error
        call    ClearBreak      ; Clear breakpoint
	jmp	short breakdone	; Get out
clearall:
        popfd                    ; ZF if -*, NZ if just * no -
	jnz	short badbreak	; not a clear
        inc     esi              ; next arg
	call	WadeSpace	; find it
	jnz	short	badbreak	;can't be more on line here
        call    ClearAllBreaks
	jmp	breakdone	;and get out
showall:
        mov     ecx,8            ; For each breakpoint
salp:
        mov     eax,8
        sub     eax,ecx
	call	displaybreak	;
	loop	salp		; for all possible 16 of them
breakdone:
	clc			; Exit, no errors
	ret
badbreak2:
        pop     eax              ;
badbreak:
	stc			; Exit, errors
	ret
Breaks  ENDP    
END