        .386
        .model flat,stdcall

include win32.ase
include win32.asi

        public  CreateConsole,DestroyConsole, TypeChar, GetKey
        public  ConsoleReset

        extrn   hInst : DWORD
        .data
threadhand      dd      0
hwndConsole      dd      0
szClassName     db      "simconsole",0
szTitleName     db      "Console",0
invisible       db      0
fontdata        label byte
        dd      16,0,0,0,FW_NORMAL
        db      0,0,0,ANSI_CHARSET,OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS
        db      DEFAULT_QUALITY,FIXED_PITCH + FF_DONTCARE
        db      "Courier New",0,32 DUP(0)
hFont    dd      0
        .data?
keycount dd     ?
keyhead dd      ?
keytail dd      ?
keybuf  dd      16 dup (?)
screenbuf       db      80*24 DUP (?)
cursx   dd      ?
cursy   dd      ?
        .code
CreateConsole PROC
        call    CreateThread,0,0,offset consolethread,0,0,offset threadhand
        ret
CreateConsole ENDP
DestroyConsole PROC
        mov     eax,[hwndConsole]
        or      eax,eax
        jz dcnocons
        call    SendMessage,[hwndConsole],WM_CLOSE,0,0
dcnocons:
        ret
DestroyConsole ENDP
GetKey PROC
        mov     eax,[keycount]
        or      eax,eax
        jz      nokey
        dec     [keycount]
        mov     eax,[keytail]
        mov     eax,[eax*4 + keybuf]
        inc     [keytail]
        and     [keytail],15
nokey:
        ret
GetKey ENDP
putkey PROC
        cmp     [keycount],16
        jz      dropkey
        inc     [keycount]
        mov     ecx,[keyhead]
        mov     [keybuf + ecx * 4],eax
        inc     [keyhead]
        and     [keyhead],15
dropkey:
        ret
putkey ENDP
TypeChar PROC
        cmp     al,20h
        jc      controlchar
        mov     edx,[cursy]
        imul    edx,80
        add     edx,[cursx]
        mov     [edx + screenbuf],al
        inc     [cursx]
incxd:
        cmp     [cursx],80
        jc      tcx
        mov     [cursx],0
incy:
        inc     [cursy]
        cmp     [cursy],24
        jc      tcx
        dec     [cursy]
        push    esi
        push    edi
        mov     edi,offset screenbuf
        mov     esi,offset screenbuf + 80
        mov     ecx,23*80
        cld
        rep     movsb
        mov     al,' '
        mov     ecx,80
        rep     stosb
        pop     edi
        pop     esi
tcx:
        call    InvalidateRect, [hwndConsole],0,1
        test    [invisible],1
        jz      noshow
        dec     [invisible]
        call    ShowWindow, [hwndConsole],SW_SHOWNORMAL
        call    SetForegroundWindow, [hwndConsole]
noshow:
        ret
controlchar:
        cmp     al,13
        jnz     notcr
        mov     [cursx],0
        ret
notcr:
        cmp     al,10
        jz      incy
        cmp     al,8
        jz      bckspace
        cmp     al,7fh
        jnz     nbckspace
bckspace:
        dec     [cursx]
        jge     dcurs
        inc     [cursx]
dcurs:
        ret
nbckspace:
        cmp     al,9
        jnz     tcx
        add     [cursx],8
        and     [cursx],0fffffff8h
        jmp     incxd
TypeChar ENDP
ConsoleReset PROC
        sub     eax,eax
        mov     [cursx],eax
        mov     [cursy],eax
        mov     [keycount],eax
        mov     [keyhead],eax
        mov     [keytail],eax
        mov     edi,offset screenbuf
        mov     al,' '
        mov     ecx,80*24
        rep     stosb
        test    [invisible],1
        jnz     alreadyinvisible
        inc     [invisible]
        call    ShowWindow, [hwndConsole],SW_HIDE

alreadyinvisible:
        ret
ConsoleReset ENDP
paint PROC      uses esi, hwnd : dword
        local   ps : PAINTSTRUCT, dc :dword
        lea     edx,[ps]
        call    BeginPaint,hwnd,edx
        mov     [dc],eax
        call    SetTextColor,eax,0ffffffh
        push    eax
        call    SetBkColor,[dc],0
        push    eax
        call    SelectObject,[dc],[hFont]
        push    eax
        mov     ecx,24
        mov     esi,offset screenbuf
scrbufout:
        push    ecx
        mov     eax,24
        sub     eax,ecx
        imul    eax,15
        call    TextOut,[dc],0,eax,esi,80
        pop     ecx
        add     esi,80
        loop    scrbufout
        pop     eax
        call    SelectObject,[dc],eax
        pop     eax
        call    SetBkColor,[dc],eax
        pop     eax
        call    SetBkColor,[dc],eax
        lea     edx,[ps]
        call    EndPaint,hwnd, edx
        ret
paint endp
WndProc PROC uses ebx edi esi, hwnd:DWORD, wmsg:DWORD, wparam:DWORD, lparam:DWORD
        cmp     [wmsg],WM_CREATE
        jnz     notcreate
        call    CreateFontIndirect, offset fontdata
        mov     [hFont],eax
        sub     eax,eax
        ret
notcreate:
        cmp     [wmsg],WM_PAINT
        jnz     notpaint
        call    paint, [hwnd]
        sub     eax,eax
        ret
notpaint:
        cmp     [wmsg],WM_CHAR
        jnz     notchar
        mov     eax,[wparam]
        call    putkey
        sub     eax,eax
        ret
notchar:
        cmp     [wmsg],WM_DESTROY
        jnz     notdestroy
        call    DeleteObject,[hFont]
notdestroy:
        call    DefWindowProc, hwnd, wmsg,wparam,lparam
        ret
WndProc ENDP
consolethread PROC uses ebx edi esi, parm : dword
        LOCAL   msg : MSGSTRUCT, wc : WNDCLASS, scrbuf : CONSOLE_SCREEN_BUFFER_INFO
        mov     [wc.clsStyle], CS_HREDRAW + CS_VREDRAW
        mov     [wc.clsLpfnWndProc], offset WndProc
        mov     [wc.clsCbClsExtra], 0
        mov     [wc.clsCbWndExtra], 0

        mov     eax, [hInst]
        mov     [wc.clsHInstance], eax

        mov     [wc.clsHIcon], 0

        call    LoadCursor,0,IDC_ARROW
        mov     [wc.clsHCursor], eax

        call    GetStockObject, BLACK_BRUSH
        mov     [wc.clsHbrBackground], eax
        mov     [dword ptr wc.clsLpszMenuName], 0
        mov     [dword ptr wc.clsLpszClassName], offset szClassName

	lea	eax,[wc]
        call    RegisterClass,eax

        call    CreateWindowEx, 0, offset szClassName, offset szTitleName, \
                        WS_THICKFRAME + WS_CAPTION + WS_SYSMENU + WS_MINIMIZEBOX + WS_MAXIMIZEBOX, \
			CW_USEDEFAULT, \
			CW_USEDEFAULT, \
                        81*8, \
                        24*16+8, \
                        0,0,[hInst],0

        mov     [hwndConsole], eax
        mov     [invisible],1
        call    ConsoleReset

msg_loop:
	lea	eax,[msg]
        call    GetMessage,eax,0,0,0
        cmp     ax, 0
        je      end_loop

	lea	eax,[msg]
        call    TranslateMessage, eax
	lea	eax,[msg]
        call    DispatchMessage, eax
        jmp     msg_loop

end_loop:
        mov     [hwndConsole],0
        ret

consolethread ENDP

        end