        .386
        .model flat,stdcall
include opcode.inc
include operand.inc

OPERANDPOS      EQU       42
OPCODEPOS       EQU      30
WORDPOS        EQU      10
WORDNUM        EQU      4
DISSIZE        EQU      15

        PUBLIC   dbg_strapp, dbg_buffer, dbg_disline,dbg_disadr, thesize
        PUBLIC  Unassemble, disindex, filloneline, left
        extrn  membase:dword, memtop:dword
        EXTRN    dbg_op1:operand,dbg_op2:operand,dbg_op3:operand,dbg_find_opcode : PROC
        EXTRN    dbg_cd_dispatch:PROC,dbg_sz_dispatch:PROC,dbg_op_dispatch:PROC
        EXTRN    dbg_putmsg:PROC,dbg_wadespace:PROC,dbg_getnumber:PROC
        EXTRN    dbg_putcr:PROC,dbg_badflag:byte,firstword : dword
        EXTRN    oldpc : dword, WadeSpace : PROC, ReadAddress : PROC,
        EXTRN    ReadNumber :PROC, GetKey : PROC,crlf : PROC
        EXTRN    WriteString : PROC

        .data
dbg_buffer  db  256 DUP(0)
namebuf db      256 DUP(0)
dbg_disadr  dd  0
left    dw        0
thesize db      0
disindex   dd      0

        .code
adcb    db        "dc.w"
null    db        0
mn_ccr  db  "ccr",0
mn_sr   db "sr",0
mn_usp  db  "usp",0
mn_sfc  db  "sfc",0
mn_dfc  db  "dfc",0
mn_cacr db   "cacr",0
mn_vbr  db  "vbr",0
mn_caar db   "caar",0
mn_msp  db  "msp",0
mn_isp  db  "isp",0

        align  4
dbg_strapp PROC
        xchg    esi,edi
strlp1:
        lodsb
        or      al,al
        jnz     strlp1
        dec     esi
        xchg    esi,edi
strlp2:
        lodsb
        stosb
        or      al,al
        jnz     strlp2
        dec     edi
        ret
dbg_strapp ENDP
tabto PROC
        xchg    esi,edi
tabtol1:
        lodsb
        or      al,al
        loopnz  tabtol1
        xchg    esi,edi
        dec     edi
        or      cl,cl
        je      foundpos
        mov     al,' '
        rep     stosb
        mov     byte ptr [edi],0
foundpos:
        ret
tabto   ENDP
putmn   PROC
        push    esi
        push    edi
        mov     edi,offset namebuf
        mov     byte ptr [edi],0
        mov     esi,[ebx + opcode.xname]
        or      esi,esi
        je      nomn
putmnl:
        lodsb
        stosb
        or      al,al
        jnz     putmnl
        dec     edi
        mov     esi,[ebx + opcode.ext]
        or      esi,esi
        je      nomn
putmnl2:
        lodsb
        stosb
        or      al,al
        jnz     putmnl2
nomn:
        pop     edi
        pop     esi
        ret
putmn   ENDP

inslong PROC
        push    eax
        shr     eax,16
        call    insword
        pop     eax
insword:
        xchg    al,ah
        call    insbyte
        xchg    al,ah
insbyte:
        push    eax
        shr     al,4
        call    insnib
        pop     eax
insnib:
        and     al,15
        add     al,'0'
        cmp     al,'9'
        jbe     insdigit
        add     al,7
insdigit:
        stosb
        ret
inslong ENDP

srtab label dword
        dd    mn_sfc, mn_dfc, mn_cacr, mn_usp
        dd    mn_vbr, mn_caar, mn_msp, mn_isp
        dd      mn_ccr, mn_sr

regn PROC
        bt      eax,BRG_SPECIAL
        jc      regnspecial
        mov     ecx,'D'
        bt      eax,3
        jnc     regndata
        mov     cl,'A'
regndata:
        xchg    al,cl
        stosb
        xchg    al,cl
        and     al,7
        add     al,'0'
        stosb
        ret
regnspecial:
        sub     eax,RG_SPECIAL
        movzx   eax,al
        push    esi
        mov     esi,[srtab + eax * 4]
regnsl:
        lodsb
        stosb
        or      al,al
        jnz     regnsl
        dec     edi
        pop     esi
        ret
regn    ENDP
baseregn PROC
        call    regn
        mov     al,'.'
        stosb
        mov     al,'w'
        mov     cx,[edx +operand.mods]
        bt      ecx,1
        jnc     baseword
        mov     al,'l'
baseword:
        stosb
chksize:
        and     ecx,0ch
        je      nosize
        mov     al,'*'
        stosb
        shr     ecx,2
        mov     al,'2'
        dec     ecx
        je      sizeit
        mov     al,'4'
        dec     ecx
        je      sizeit
        mov     al,'8'
sizeit:
        stosb
nosize:
        ret
baseregn ENDP
aindr   PROC
        push    eax
        mov     al,'('
        stosb
        pop     eax
        call    regn
        mov     al,')'
        stosb
        ret
aindr   ENDP
apostinc PROC
        call    aindr
        mov     al,'+'
        stosb
        ret
apostinc ENDP
apredec PROC
        push    eax
        mov     al,'-'
        stosb
        pop     eax
        jmp     aindr
apredec ENDP
aindex PROC
        mov     al,'('
        stosb
        mov     al,'$'
        stosb
        mov     eax,[edx + operand.bd]
        call    inslong
        mov     al,','
        stosb
        mov     al,[edx + operand.r1]
        call    regn
        mov     al,')'
        stosb
        ret
aindex ENDP
pcindex PROC
        mov     al,'('
        stosb
        mov     al,'$'
        stosb
        mov     eax,[edx + operand.bd]
        call    inslong
        mov     al,','
        stosb
        mov     al,'P'
        stosb
        mov     al,'C'
        stosb
        mov     al,')'
        stosb
        ret
pcindex ENDP
based PROC
        mov     al,'('
        stosb
        mov     al,'$'
        stosb
        mov     eax,[edx + operand.bd]
        call    inslong
        mov     al,','
        stosb
        mov     al,[edx + operand.r1]
        call    regn
        mov     al,','
        stosb
        mov     al,[edx + operand.r2]
        call    baseregn
        mov     al,')'
        stosb
        ret
based ENDP
pcbased PROC
        mov     al,'('
        stosb
        mov     al,'$'
        stosb
        mov     eax,[edx + operand.bd]
        call    inslong
        mov     al,','
        stosb
        mov     al,'P'
        stosb
        mov     al,'C'
        stosb
        mov     al,','
        stosb
        mov     al,[edx + operand.r2]
        call    baseregn
        mov     al,')'
        stosb
        ret
pcbased ENDP
mem PROC
        mov     al,'('
        stosb
        mov     al,'['
        stosb
        mov     cx,[edx + operand.mods]
        shr     cx,4
        and     cx,3
        dec     cx
        mov     al,0
        je      nomembase
        mov     al,'$'
        stosb
        mov     eax,[edx+operand.bd]
        shr     cx,1
        mov     ecx,0
        je      membaseword
        call    inslong
        jmp     mbdone
membaseword:
        call    insword
mbdone:
        mov     al,1
nomembase:    
        mov     cx,[edx + operand.mods]
        test    cx,BASESUPPRESS
        jne     nomembasereg
        or      al,al
        je      nocomma1
        mov     al,','
        stosb
nocomma1:
        mov     al,[edx+operand.r1]
        call    regn
nomembasereg:
        mov     cx,[edx + operand.mods]
        test    cx,INDEXSUPPRESS
        jne     noindex
        test    cx,POSTINDEX
        je      incomma
        mov     al,']'
        stosb
incomma:
        test    al,al
        je      doindex
        mov     al,','
        stosb
doindex:
        mov     al,[edx + operand.r2]
        call    baseregn
        or      al,1
noindex:
        mov     cx,[edx + operand.mods]
        test    cx,POSTINDEX
        jne     nobracket
        mov     al,']'
        stosb
nobracket:
        shr     cx,6
        and     cx,3
        dec     cx
        je      nood
        mov     al,','
        stosb
        mov     al,'$'
        stosb
        mov     eax,[edx + operand.od]
        shr     cx,1
        je      odword
        call    inslong
        jmp     nood
odword:
        call    insword
nood:
        mov     al,')'
        stosb
        ret
mem     endp        
pcmem PROC
        mov     al,'('
        stosb
        mov     al,'['
        stosb
        mov     cx,[edx + operand.mods]
        shr     cx,4
        and     cx,3
        dec     cx
        mov     al,0
        je      pcnomembase
        mov     al,'$'
        stosb
        mov     eax,[edx+operand.bd]
        shr     cx,1
        mov     ecx,0
        je      pcmembaseword
        call    inslong
        jmp     pcmbdone
pcmembaseword:
        call    insword
pcmbdone:
        mov     al,','
        stosb
pcnomembase:    
        mov     cx,[edx + operand.mods]
        test    cx,BASESUPPRESS
        je      pcbasepc
        mov     al,'z'
        stosb
pcbasepc:
        mov     al,'p'
        stosb
        mov     al,'c'
        stosb
pcnomembasereg:
        test    cx,INDEXSUPPRESS
        jne     pcnoindex
        test    cx,POSTINDEX
        je      pcincomma
        mov     al,']'
        stosb
pcincomma:
        mov     al,','
        stosb
pcdoindex:
        mov     al,[edx + operand.r2]
        call    baseregn
        or      al,1
pcnoindex:
        mov     cx,[edx + operand.mods]
        test    cx,POSTINDEX
        jne      pcnobracket
        mov     al,']'
        stosb
pcnobracket:
        shr     cx,6
        and     cx,3
        dec     cx
        je      pcnood
        mov     al,','
        stosb
        mov     al,'$'
        stosb
        mov     eax,[edx + operand.od]
        shr     cx,1
        je      pcodword
        call    inslong
        jmp     pcnood
pcodword:
        call    insword
pcnood:
        mov     al,')'
        stosb
        ret
pcmem ENDP
imm PROC
        mov     al,'#'
        stosb
        mov     al,'$'
        stosb
        mov     eax,[edx + operand.bd]
        mov     cx,[edx + operand.mods]
        and     cx,30h
        je      insbyte
        cmp     cx,20h
        je      insword
        jmp     inslong
imm ENDP
absw PROC
        mov     al,'('
        stosb
        mov     al,'$'
        stosb
        mov     eax,[edx + operand.bd]
        call    insword
        mov     al,')'
        stosb
        mov     al,'.'
        stosb
        mov     al,'w'
        stosb
        ret
absw ENDP
absl PROC
        mov     al,'('
        stosb
        mov     al,'$'
        stosb
        mov     eax,[edx + operand.bd]
        call    inslong
        mov     al,')'
        stosb
        mov     al,'.'
        stosb
        mov     al,'l'
        stosb
        ret
absl ENDP
rel PROC
        mov     al,'$'
        stosb
        mov     eax,[edx + operand.bd]
        jmp     inslong
rel ENDP
bfregimm PROC
        btr     eax,5
        jc      regn
        jmp     insbyte
bfregimm ENDP
bf PROC
        mov     al,'{'
        stosb
        mov     al,[edx + operand.r1]
        call    bfregimm
        mov     al,':'
        stosb
        mov     al,[edx + operand.r2]
        call    bfregimm
        mov     al,'}'
        stosb
        ret
bf ENDP
mdreg PROC
        mov     al,[edx + operand.r1]
        push    eax
        call    regn
        pop     eax
        mov     cl,[edx + operand.r2]
        cmp     al,cl
        je      noreg2
        mov     al,':'
        stosb
        mov     al,cl
        call    regn
noreg2:
        ret
mdreg ENDP
cas2reg PROC
        mov     al,[edx + operand.r1]
        call    regn
        mov     al,':'
        stosb
        mov     al,[edx + operand.r2]
        jmp     regn
cas2reg ENDP
cas2reg2 PROC
        mov     al,[edx + operand.r1]
        call    aindr
        mov     al,':'
        stosb
        mov     al,[edx + operand.r2]
        jmp     aindr
cas2reg2 ENDP
movecreg PROC
        ret
movecreg ENDP
nmovem PROC
        push    edx
        movzx   edx,word ptr [edx + operand.r1]
        mov     ecx,8
movemd:
        shr     dx,1
        jnc     nomovemd
        bts     edx,16
        jnc     noslash1
        mov     al,'/'
        stosb
noslash1:
        mov     al,'D'
        stosb
        mov     al,cl
        neg     al
        add     al,8 + '0'
        stosb
nomovemd:
        loop    movemd
        mov     ecx,8
movema:
        shr     dx,1
        jnc     nomovema
        bts     edx,16
        jnc     noslash2
        mov     al,'/'
        stosb
noslash2:
        mov     al,'A'
        stosb
        mov     al,cl
        neg     al
        add     al, 8 +'0'
        stosb
nomovema:
        loop    movema
        pop     edx
        ret
nmovem ENDP        
opertable label dword
        dd    none, regn, aindr
        dd    apostinc, apredec, aindex
        dd    pcindex, based, mem
        dd    pcbased, pcmem, imm
        dd    absw, absl, bf
        dd    mdreg, cas2reg, cas2reg2
        dd    movecreg, nmovem, rel

putoperand PROC
        movzx   ecx,[edx + operand.xtype]
        mov     ecx,[opertable + ecx * 4]
        mov     al,[edx + operand.r1]
        call    ecx
        sub     al,al
        stosb
        dec     edi
none:
        ret
putoperand ENDP

putpunct PROC
        mov     ax,[edx+operand.xtype]
        or      ax,ax
        je      nopunc
        cmp     al,BF
        je      psp
        mov     al,','
        stosb
        ret
psp:
        mov     al,' '
        stosb
nopunc:
        ret
putpunct ENDP
filloneline     PROC
        mov     edi,offset dbg_buffer
        mov     eax,esi
        sub     eax,[membase]
        call    inslong
        mov     al,':'
        stosb
        mov     al,' '
        stosb
        sub     al,al
        stosb
        mov     edi,offset dbg_buffer
        mov     ecx,OPCODEPOS
        call    tabto
        call    dbg_find_opcode
        jns     found
        jmp     lost
lost2:
        pop     eax
lost:
        mov     edi,offset dbg_buffer
        mov     esi,offset adcb
        call    dbg_strapp
        mov     edi,offset dbg_buffer
        mov     ecx,OPERANDPOS
        call    tabto
        mov     al,'$'
        stosb
        mov     eax,[firstword]
        call    insword
        sub     al,al
        stosb
        mov     esi,[oldpc]
        inc     esi
        inc     esi
        ret
found:
        call    putmn
        mov     al,[ebx + operand.xsize]
        call    dbg_sz_dispatch
        mov     [thesize],al

        mov     al,[ebx + operand.source]
        mov     edi,offset dbg_op1
        call    dbg_op_dispatch
        jnz     lost2

        mov     al,[ebx + operand.dest]
        mov     edi,offset dbg_op2
        call    dbg_op_dispatch
        jnz     lost2

        mov     al,[ebx + operand.alt]
        mov     edi,offset dbg_op3
        call    dbg_op_dispatch
        jnz     lost2

        push    esi
        mov     edi,offset dbg_buffer
        mov     esi,offset namebuf
        call    dbg_strapp
        pop     esi

        mov     al,[ebx + operand.code]
        call    dbg_cd_dispatch

        mov     cl,[thesize]
        or      cl,cl
        je      sz_done
        mov     al,'.'
        stosb
        mov     al,'b'
        dec     cl
        je      sz_p
        mov     al,'w'
        shr     cl,1
        jc      sz_p
        mov     al,'l'
sz_p:
        stosb
sz_done:
        sub     al,al
        stosb
        mov     edi,offset dbg_buffer
        mov     ecx,OPERANDPOS
        call    tabto
        mov     edx,offset dbg_op1
        call    putoperand
        mov     edx,offset dbg_op2
        call    putpunct
        call    putoperand
        mov     edx,offset dbg_op3
        call    putpunct
        call    putoperand
        movzx   eax,[ebx + opcode.len]
        add     eax,[oldpc]
        cmp     eax,esi
        jb      keepesi
        xchg    eax,esi
keepesi:
        ret
filloneline     ENDP
dbg_disline PROC
        mov     [dbg_buffer],0
        movzx   ecx,[left]
        or      ecx,ecx
        jne     fillnums
        call    filloneline
        mov     edi,offset dbg_buffer
        mov     ecx,OPCODEPOS
        call    tabto
        mov     ecx,esi
        sub     ecx,[oldpc]
fillnums:
        push    ecx
        mov     edi,offset dbg_buffer
        mov     ecx,WORDPOS
        call    tabto
        pop     ecx

        mov     dx,[left]
        mov     [left],0
        cmp     ecx,WORDNUM*2
        jbe     lessnum
        sub     ecx,WORDNUM*2
        mov     [left],cx
        mov     ecx,WORDNUM*2
lessnum:
        push    esi
        mov     esi,[oldpc]
        add     [oldpc],ecx
        shr     ecx,1
wordlp:
        lodsw
        xchg    al,ah
        call    insword
        mov     al,' '
        stosb
        loop    wordlp
        or      dx,dx
        jz      wordn
        mov     al,0
        stosb
wordn:
        pop     esi
        ret
dbg_disline ENDP
Unassemble PROC
        mov     ecx,48          ; Default amount to dump
	call	WadeSpace	; Wade to end of spaces
        jz      short atIndex   ;
	call	ReadAddress	; Else read start address
	jc	dudone		; Quit on error
	call	WadeSpace	; Wade through spaces
        jz      short doUnas    ;
	call	ReadNumber	; Else read end offset
	jc	short dudone	;
	sub	eax,ebx		; Calculate length of dump
	mov	ecx,eax		;
        jmp     short doUnas    ; Go do dump
atIndex:
        mov     ebx,[disindex]     ; Assume we want to dump from last index
doUnas:
        mov     esi,ebx
        add     esi,[membase]
unasLp:
        call    GetKey
        or      eax,eax
        jnz      dudone
        call    crlf
        push    esi
        push    ecx
        call    dbg_disline
        pop     ecx
        pop     edx
        mov     edi,offset dbg_buffer
        call    WriteString
        cmp     esi,[memtop]
        jae     dudone
        mov     eax,esi
        sub     eax,edx
        sub     ecx,eax
        jg      unasLp
        sub     esi,[membase]
        mov     [disindex],esi
        clc
dudone:
        ret
Unassemble ENDP
        end