        .486
        .model  flat,stdcall

include win32.ase
include win32.asi

        public  membase,memtop,hasvects,finish, xxfil, filesize, memsize
        public  debug
        extrn   termio_init : PROC, termio_rundown : PROC
        extrn   WriteString : proc, crlf : PROC
        extrn   dbg_disline : PROC, dbg_buffer : byte
        extrn   GetKey :PROC, WriteChar : PROC
        extrn   Inputhandler : PROC, DisplayRegisters : PROC
        extrn   prm_00 : byte, SR : dword, PC : dword, Dregs : dword
        extrn   emuinit : PROC, emudll : byte, emurundown : PROC
        extrn   emugetparms : PROC, PrintDword : PROC, oldsr : word
        extrn   ISP : dword, run:proc

        .data
membase dd      0
memtop  dd      0
memsize dd      0
filesize dd     0
heaphand dd     0
binhand dd      0
readlen dd      0
xxfil   db      256 dup (0) ;
debug   db      0
hasvects db     0
erroccurred     db "an error occurred reading ",0
cantopen        db "Can't open ",0
couldnotfinddll db  "Could not find emulation dll - ",0
Usage   label   byte
        db      13,10,"SIM-68K Version 1.00  Copyright (C) LADSoft (2002)",13,10,13,10
        db      "Usage: sim68 options filename",13,10
        db      " /0      - 68000 emulation (defaults to 68020)",13,10
        db      " /d      - enable debugger",13,10
        db      " /Ename  - specify emulation library",13,10
        db      " /M#     - suggest a maximum amount of memory",13,10
        db      " /V      - image has a vector table at address 0",13,10
        db      13,10,"filename is the name of the image to load",13,10
        db      0
        .code

getnum PROC
        mov     ecx,0
        sub     eax,eax
gnl:
        lodsb
        sub     al,'0'
        jc      endnum
        cmp     al,10
        jae     endnum
        imul     ecx,10
        add     ecx,eax
        jmp     gnl
endnum:
        dec     esi
        mov     eax,ecx
        ret
getnum ENDP
skipprogname PROC
        sub     cl,cl
spnl:
        lodsb
        or      al,al
        jnz     spnc
        dec     esi
        ret
spnc:
        cmp     al,cl
        jnz     chkskip
        sub     cl,cl
        jmp     spnl
chkskip:
        or      cl,cl
        jnz     spnl
        cmp     al,'"'
        jnz     noskip
        mov     cl,al
        jmp     spnl
noskip:
        cmp     al,' '
        jnz     spnl
splp:
        lodsb
        cmp     al,' '
        jz      splp
        dec     esi
        ret
skipprogname ENDP
scanoptions PROC
        lodsb
sol:
        cmp     al,'/'
        jz      option
        cmp     al,'-'
        jz      option
        dec     esi
        ret
option:
        lodsb
        cmp     al,'d'
        jnz     notd
        or      [debug],1
        jmp     scanspace
notd:
        cmp     al,'0'
        jnz     not0
        or      [prm_00],1
        jmp     scanspace
not0:
        cmp     al,'M'
        jnz     notm
        call    getnum
        shl     eax,10
        mov     [memsize],eax
        mov     [memtop],eax
        jmp     scanspace
notm:
        cmp     al,'V'
        jnz     notv
        mov     [hasvects],1
        jmp     scanspace
notv:
        cmp     al,'E'
        jnz     note
        mov     edi,offset emudll
elp:
        lodsb
        cmp     al,' '
        jz      edn
        stosb
        or      al,al
        jnz      elp
        jmp     sol
edn:
        sub     al,al
        stosb
        jmp     scanspace
note:
        mov     edi,offset Usage
        call    WriteString
        call    ExitProcess, 0
scanspace:
        lodsb
        cmp     al,' '
        jz      scanspace
        jmp     sol
scanoptions ENDP

getparms PROC
        call    GetCommandLine
        mov     esi,eax
        call    skipprogname
        call    scanoptions
        mov     edi,offset xxfil
gpl:
        lodsb
        cmp     al,' '
        jnz     notdone
        sub     al,al
notdone:
        stosb
        or      al,al
        jnz     gpl
gpx:
        ret
getparms ENDP

start proc near
        call    termio_init

        call    getparms

        call    emuinit
        jnc     emuok
        mov     edi,offset couldnotfinddll
        call    WriteString
        mov     edi,offset emudll
        call    WriteString
        jmp     exit

emuok:
        call    emugetparms
        mov     eax,[eax]
        cmp     eax,[memsize]
        jc      egp_nomem
        mov     [memsize],eax
        mov     [memtop],eax
egp_nomem:
        mov     al,[xxfil]
        or      al,al
        jnz     ok
        mov     edi,offset Usage
        call    WriteString
        jmp     exit

ok:
        call    CreateFile, offset xxfil,GENERIC_READ,0,0,OPEN_EXISTING,0,0
        mov     [binhand],eax
        cmp     eax,INVALID_HANDLE_VALUE
        jnz     opened

        mov     edi,offset cantopen
        call    WriteString
        mov     edi,offset xxfil
        call    WriteString
        jmp     exit

opened:
        call    SetFilePointer,  binhand,0,0,FILE_END
        call    SetFilePointer,  binhand,0,0,FILE_CURRENT
        push    eax  
        call    SetFilePointer,  binhand,0,0,FILE_BEGIN
        pop     eax
        cmp     eax,INVALID_FILE_SIZE
        jz      closeexit

        mov     [filesize],eax
        cmp     eax,[memtop]
        jc      gotsize
        mov     [memtop],eax
        mov     [memsize],eax
gotsize:

        call    GlobalAlloc,GMEM_FIXED,eax
        or      eax,eax
        jz      closeexit

        mov     [heaphand],eax

        call    GlobalLock,      eax
        or      eax,eax
        jz      heapcloseexit

        add     [memtop],eax
        mov     [membase],eax

        call    ReadFile, [binhand],eax,[filesize],offset readlen,0
        or      eax,eax
        je      heapcloseexit

        call    CloseHandle, [binhand]

        mov     [SR],00270000h
        mov     ax,word ptr [SR+2]
        mov     [oldsr],ax  
        test    [hasvects],1
        jz      not_vects
        mov     eax,[membase]
        mov     ecx,[eax]
        mov     [Dregs + 15 * 4],ecx
        mov     [ISP],ecx
        mov     ecx,[eax+4]
        bswap   ecx
        mov     [PC],ecx
not_vects:

        call    emugetparms

        test    [debug],1
        jnz     godebug
        call    Sleep,  500
        call    run
        jmp     finish
godebug:
        call    DisplayRegisters
        call    Inputhandler
finish:
        call    GlobalFree,[heaphand]        
        jmp     exit

heapcloseexit:
        call    GlobalFree,[heaphand]

closeexit:
        call    CloseHandle, [binhand]
        mov     edi,offset erroccurred
        call    WriteString
        mov     edi,offset xxfil
        call    WriteString

exit:
        call    emurundown
        call    termio_rundown
        call    ExitProcess,    0

start endp

        end     start